<div class="wrap">
<?php screen_icon( 'users' ); ?>
<h2><?php echo esc_html( __( 'Group Message', 'aag' ) ); ?></h2>

<table class="widefat" style="margin-top: 1em;">
<tbody>
<tr>

<td scope="col" style="width: 60px">
<p><?php echo get_avatar( $message->user_id, 48 ); ?></p>
</td>

<td scope="col">
<p><strong><?php
$user = get_userdata( $message->user_id );
echo '<a href="' . aag_admin_url( 'messages.php', array( 'author_id' => $message->user_id ) ) . '" title="' . esc_attr( stripslashes( $user->display_name ) ) . '">' . esc_html( $user->user_login ) . '</a>';
?></strong>&emsp;<?php echo apply_filters( 'aag_message_content', stripslashes( $message->message_content ) ); ?></p>

<p class="row-actions">
<?php
$links = array();

if ( $message->user_id != $current_user->ID && aag_you_can_message_group( $message->group_id ) ) {
	$link_url = aag_admin_url( 'messages.php', array(
		'reply_to' => $message->message_id ) );
	$links[] = '<span><a href="' . $link_url . '">' . esc_html( __( 'Reply', 'aag' ) ) . '</a></span>';
}

if ( aag_you_can_delete_message( $message->message_id ) ) {
	$link_url = aag_admin_url( 'messages.php', array(
		'message_id' => $message->message_id,
		'aag-message-delete' => 1 ) );
	$link_url = wp_nonce_url( $link_url,
		'aag-message-delete-' . $message->message_id );
	$links[] = '<span class="delete"><a href="' . $link_url . '" onclick="if (confirm(\''
		. esc_js( __( "You are about to delete this message.\n'Cancel' to stop, 'OK' to delete.", 'aag' ) ) . '\')) {return true;} return false;">' . esc_html( __( 'Delete', 'aag' ) ) . '</a></span>';
}

echo implode( ' | ', $links );
?>
</p>

</td>

<td scope="col" style="width: 120px">
<p><?php $mg = aag_get_group( $message->group_id );
echo '<a href="' . aag_admin_url( 'messages.php', array( 'group_id' => $message->group_id ) )
	. '"><strong>' . esc_html( stripslashes( $mg->group_name ) ) . '</strong></a>'; ?>
<br /><?php
$message_posted = mysql2date( 'U', $message->posted );
if ( ( time() - $message_posted ) < 86400 * 7 ) {
	$date = sprintf( __( '%s ago', 'aag' ), human_time_diff( $message_posted ) );
} else {
	$date = mysql2date( __( 'Y/m/d H:i', 'aag' ), $message->posted );
}
$message_url = aag_admin_url( 'messages.php', array( 'message_id' => $message->message_id ) );
echo '<a href="' . $message_url . '">' . esc_html( $date ) . '</a>';

if ( $message->reply_to ) {
	$replied = aag_get_message_by_id( $message->reply_to );
	$replied_user = get_userdata( $replied->user_id );
	$replied_url = aag_admin_url( 'messages.php', array( 'message_id' => $replied->message_id ) );
	$text = sprintf( __( 'in reply to %s', 'aag' ), $replied_user->user_login );
	echo '<br /><a href="' . $replied_url . '">' . esc_html( $text ) . '</a>';
}
?>
</p>
</td>

</tr>
</tbody>
</table>

</div>