<?php

/* One message view */

if ( ( $message_id = (int) $_GET['message_id'] )
	&& ( $message = aag_get_message_by_id( $message_id ) )
	&& aag_you_can_message_group( $message->group_id ) ) {

	require_once AAG_PLUGIN_DIR . '/admin/message.php';
	return;
}

/* Message list view */

$groups = aag_get_your_groups();
$group_id = (int) $_GET['group_id'];

$reply_to = (int) $_GET['reply_to'];
if ( $replied_message = aag_get_message_by_id( $reply_to ) )
	$group_id = $replied_message->group_id;

if ( $group_id && aag_you_can_message_group( $group_id ) ) {
	$group = aag_get_group( $group_id );
} else {
	$group_id = null;
	$all = true;
}

if ( $author_id = (int) $_GET['author_id'] )
	$author = get_userdata( $author_id );

$messages = aag_your_group_timeline( array(
	'group_id' => $group_id,
	'author_id' => $author_id,
	'perpage' => 20,
	'search' => $_GET['s'] ) );

?><div class="wrap">
<?php screen_icon( 'users' ); ?>
<h2><?php echo esc_html( __( 'Group Messages', 'aag' ) ); ?></h2>

<?php if ( isset( $_GET['deleted'] ) ) : ?>
<div id="message" class="updated fade"><p><?php echo esc_html( __( 'Message deleted.', 'aag' ) ); ?></p></div>
<?php endif; ?>

<ul class="subsubsub">
<?php foreach ( $groups as $g ) :
	$current = ( $g->group_id == $group_id ) ? ' class="current"' : '';
	$messages_url = aag_admin_url( 'messages.php', array( 'group_id' => $g->group_id ) );
	$messages_link = '<a href="' . $messages_url . '"' . $current . '>' . esc_html( stripslashes( $g->group_name ) ) . '</a>';
?>
	<li><?php echo $messages_link ?> |</li>
<?php endforeach;

	$current = $all ? ' class="current"' : '';
	$messages_url = aag_admin_url( 'messages.php' );
	$messages_link = '<a href="' . $messages_url . '"' . $current . '>' . esc_html( __( 'Show all', 'aag' ) ) . '</a>';
?>
	<li class="showall"><?php echo $messages_link ?></li>
</ul>

<br class="clear" />

<?php if ( $group_id ) : ?>
<h3><?php echo esc_html( stripslashes( $group->group_name ) ); ?>
<span class="group-description-next-to-name"><?php echo esc_html( stripslashes( $group->group_description ) ); ?></span>
</h3>
<?php elseif ( $author_id ) : ?>
<h3><?php echo esc_html( stripslashes( $author->user_login ) );
if ( $author->user_login != $author->display_name ) : ?>
<span class="group-description-next-to-name"><?php echo esc_html( stripslashes( $author->display_name ) ); ?></span>
<?php endif; ?>
</h3>
<?php endif; ?>

<?php if ( $group_id ) : ?>
<form action="<?php echo aag_admin_url( 'messages.php' ); ?>" method="post">
<p>
<?php wp_nonce_field( 'aag-add-new-message-' . $group->group_id ); ?>
<input type="hidden" name="group_id" value="<?php echo $group->group_id; ?>" />

<?php if ( $replied_message ) : ?>
<input type="hidden" name="reply_to" value="<?php echo $reply_to; ?>" />
<strong><?php $user = get_userdata( $replied_message->user_id );
echo esc_html( sprintf( __( 'In reply to %s\'s message', 'aag' ), $user->user_login ) ); ?></strong>
&emsp;<span style="color: #5a5a5a"><?php echo wptexturize( stripslashes( $replied_message->message_content ) ); ?></span>
<?php $atremark = '@' . $user->user_login . ' ';
endif; ?>

<textarea name="message-content" cols="40" rows="2" style="width: 100%"><?php echo $atremark; ?></textarea>
<input type="submit" name="aag-add-new-message" value="<?php echo esc_attr( __( 'Send Message', 'aag' ) ); ?>" class="button" />
</p>
</form>
<?php endif; ?>

<?php if ( $messages || ! empty( $_GET['s'] ) ) : ?>
<form action="" method="get">
<p class="search-box">
	<label class="screen-reader-text" for="message-search-input"><?php echo esc_html( __( 'Search Messages:', 'aag' ) ); ?></label>
	<input type="text" id="message-search-input" name="s" value="<?php echo esc_attr( stripslashes( $_GET['s'] ) ); ?>" />
	<input type="hidden" name="page" value="<?php echo AAG_PLUGIN_NAME . '/admin/messages.php'; ?>" />
	<input type="hidden" name="group_id" value="<?php echo $group_id; ?>" />
	<input type="hidden" name="author_id" value="<?php echo $author_id; ?>" />
	<input type="submit" value="<?php echo esc_attr( __( 'Search Messages', 'aag' ) ); ?>" class="button" />
</p>
</form>

<?php if ( empty( $messages ) ) {
	echo '<h4>' . sprintf( __( 'No results for &#8220;%s&#8221;', 'aag' ),
		esc_html( stripslashes( $_GET['s'] ) ) ) . '</h4>';
} ?>
<?php endif; ?>

<?php if ( $messages ) : ?>

<table id="aag-messages-timeline" class="widefat" style="margin: 0.5em 0 1em;">
<thead><tr><th scope="col" colspan="3"><?php
if ( empty( $_GET['s'] ) ) {
	echo esc_html( __( 'Timeline', 'aag' ) );
} else {
	echo sprintf( __( 'Search results for &#8220;%s&#8221;', 'aag' ),
		esc_html( stripslashes( $_GET['s'] ) ) );
}
?></th></tr></thead>

<tfoot class="more"></tfoot>

<?php
$more_messages = array_splice( $messages, 10 );
$alt = 0;
require AAG_PLUGIN_DIR . '/admin/timeline.php';

if ( $messages = $more_messages ) {
	$hidden = true;
	require AAG_PLUGIN_DIR . '/admin/timeline.php';
}
?>

</table>

<script type="text/javascript">
//<![CDATA[
_aag.groupId = <?php echo absint( $group_id ); ?>;
_aag.authorId = <?php echo absint( $author_id ); ?>;
//]]>
</script>
<?php endif; ?>

</div>