<?php

function aag_add_group_capability() {
	return apply_filters( 'aag_add_group_capability', AAG_ADD_GROUP_CAPABILITY );
}

function aag_join_group_capability() {
	return apply_filters( 'aag_join_group_capability', AAG_JOIN_GROUP_CAPABILITY );
}

function aag_you_can_add_group() {
	return current_user_can( aag_add_group_capability() );
}

function aag_you_can_edit_group( $group_id ) {
	global $current_user;

	if ( ! $group_id = absint( $group_id ) )
		return false;

	$user_id = (int) $current_user->ID;

	if ( ! $membership = aag_get_membership( $group_id, $user_id ) )
		return false;

	if ( 'founder' == $membership->member_status || 'admin' == $membership->member_status )
		return true;

	return false;
}

function aag_you_can_delete_group( $group_id ) {
	global $current_user;

	if ( ! $group_id = absint( $group_id ) )
		return false;

	$user_id = (int) $current_user->ID;

	if ( ! $membership = aag_get_membership( $group_id, $user_id ) )
		return false;

	if ( 'founder' == $membership->member_status )
		return true;

	return false;
}

function aag_you_can_promote_member( $group_id ) {
	return aag_you_can_delete_group( $group_id );
}

function aag_you_can_accept_member( $group_id ) {
	return aag_you_can_edit_group( $group_id );
}

function aag_you_can_message_group( $group_id ) {
	global $current_user;

	if ( ! $group_id = absint( $group_id ) )
		return false;

	$user_id = (int) $current_user->ID;

	if ( ! $membership = aag_get_membership( $group_id, $user_id ) )
		return false;

	if ( in_array( $membership->member_status, array( 'founder', 'admin', 'member' ) ) )
		return true;

	return false;
}

function aag_you_can_delete_message( $message_id ) {
	global $current_user;

	if ( ! $message = aag_get_message_by_id( $message_id ) )
		return false;

	if ( $current_user->ID == $message->user_id )
		return true;

	if ( ! $membership = aag_get_membership( $message->group_id ) )
		return false;

	if ( in_array( $membership->member_status, array( 'founder', 'admin' ) ) )
		return true;

	return false;
}

?>