<?php
/* @Fitr Theme Options Plugin (http://wpwave.com)
 * ---Admin Page---
 */
 	if ( __FILE__ == $_SERVER['SCRIPT_FILENAME'] ) die();
 
	if (!current_user_can( 'manage_options' ) )
			die( 'Sorry, you do not have the right to access this page.' );
			
	global $fitr_registered_options,$fitr_registered_styles,$fto_custom_fields;

	//Make a santized array of $_POST values
	foreach ( $_POST as $key => $value)  {	
			if ( !is_array( $value) ) 
				// If it is not WPMU allow user to add Javascript to the footer
				if ( (!fto_is_wpmu() ) && ('fto_footer_code'==$key)&& (current_user_can('unfiltered_html') )) 
					$post['fto_footer_code']=str_replace("\\", "", $value);
				else
					$post[$key]=esc_attr(stripslashes($value));	
			else
			 	foreach ( $value as $val) {
					$post[$key][]=esc_attr(stripslashes($val));
				}
	}
	
	if ( isset( $_POST['fto_submit'] ) )  {
		check_admin_referer('fitr-options');
		update_option('fto_settings',$post);
		$style=fto_make_style( $post);	// Make style code and save it
		update_option('fto_style',$style);
		$msg=sprintf(__('Options successfully saved. <a href="%s">View Site &raquo;</a>','fto'),get_option('siteurl') );
		
	}elseif ( isset( $_POST['fto_restore'] ) ) {
		check_admin_referer('fitr-options');
		fto_restore();
		$msg=sprintf(__('Default settings restored. <a href="%s">View Site &raquo;</a>','fto'),get_option('siteurl') );
		
	}elseif ( (isset( $_GET['msg'] ) ) && ('upload'==$_GET['msg'] ) ) {
		$msg=sprintf(__('Header image successfully updated. <a href="%s">View Site &raquo;</a>','fto'),get_option('siteurl') );
	}
	
	$settings=get_option('fto_settings'); //Get current settings
	update_option('fto_preview',get_option('fto_style') );  //Remove old preview and update it.
	
	do_action('fto_head_action');
	
	?>
    
	<style type="text/css" media="screen">.form-table th{width: 150px;} #number-input{width:60px}label{vertical-align:baseline}</style>
   

  
	<div class="wrap">
	<?php screen_icon(); ?>
	<h2><?php esc_html_e('Fitr Theme Options','fto'); ?></h2>
			
	<?php
	if ( !isset( $fitr_registered_options) ) { ?>
		<div class="error">
				<p><?php esc_html_e('No Options Defined','fto' ); ?></p>
		</div>
		<p><?php esc_html_e('The theme you are currently using doesn&#8217;t support fitr Theme Options, meaning that it has no options that you are able to change. For information on making your theme to support fitr Theme Options, please <a href="http://wpwave.com/plugins/fitr-theme-options/">follow these instructions</a>.','fto'); ?></p>
		</div>
	<?php exit;
	}?>

	<?php if ( $msg) { ?><div id="message" class="updated fade"><p><?php echo $msg;?></p></div><?php } ?>
	
    <fieldset class="options" id="show-this-fieldset">
    
    	<h3><?php esc_html_e('Header','fto'); ?></h3>
        <table class="form-table" id="header_options">
    
          <?php 
          //If theme supports custom header there is no problem otherwise we need three defined variables to add custom header image ourself.
         if ( (defined('HEADER_IMAGE_WIDTH') ) ||( ( $fitr_registered_options['headerimg_width'] ) && ( $fitr_registered_options['headerimg_height'] ) && ( $fitr_registered_options['header_background'] ) )  ) { ?>
            <tr valign="top" id="hide_1_box">
            <th scope="row">
            <?php esc_html_e('Header Image','fto');?></th>
            <td>
            <form method="post" enctype="multipart/form-data" action="<?php bloginfo('siteurl'); ?>/wp-admin/admin.php?page=custom-header&amp;step=2" style="padding:0;margin:0;"><?php esc_html_e('Choose an image from your computer:','fto'); echo ' '. $fitr_registered_options['headerimg_width'].' x '.$fitr_registered_options['headerimg_height']; ?> <?php esc_html_e('pixels','fto');?><br/>
            <input type="file" name="import" /><input type="submit" class="button" value="<?php esc_html_e('Upload','fto');?>" name="upload-image-submit"/>
            <?php wp_nonce_field('custom-header'); ?>
            </form>
            </td></tr>
    <?php } ?>
          
  <form enctype="multipart/form-data" name="fto_form" id="fto_form" method="post" action="">
        
          <?php wp_nonce_field('fitr-options');?>
         
          <?php 
		  //If theme support custom header image or we add that ability
		  if ( (defined('HEADER_IMAGE_WIDTH') ) || ( ( $fitr_registered_options['headerimg_width'] ) && ( $fitr_registered_options['headerimg_height'] ) && ( $fitr_registered_options['header_background'] ) )  ) { ?>
          <tr valign="top">
            <th scope="row">
           </th>
            <td >
            
             <label><input type="checkbox" value="1" name="fto_header_hide" id="hide_1" <?php if ( $settings['fto_header_hide'] ) echo 'checked="checked"';?>/> 
             <?php esc_html_e('Hide header image and use background color instead.','fto'); ?></label>  <label >  <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_headerbg_color'];?>" class="color {required:false} header_color"  name="fto_headerbg_color" id="number-input" /></label> 
            </td>
           </tr>
          <?php } ?>
           
          <?php  //If the theme does not have header image and have a colorful background instead we will display these fields.
          if ( ( $fitr_registered_options['header_background'] ) && (!$fitr_registered_options['headerimg_width'] ) && (!$fitr_registered_options['headerimg_height'] ) ) { ?>
          <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Header Background','fto');?></th>
            <td>
            
             <label><?php esc_html_e('Background Color','fto');?>
              #<input type="text" value="<?php echo $settings['fto_headerbg_color'];?>" class="color {required:false}"  name="fto_headerbg_color" id="number-input" /></label> 
            </td>
           </tr>
     <?php } ?>
           
           
           
     <?php if ( $fitr_registered_options['blogtitle'] ) { ?>
            <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Blog Title','fto');?></th>
            <td>
            
            <span id="hide_2_box">
            <label> <?php esc_html_e('Color','fto');?> #<input type="text" value="<?php echo $settings['fto_blogtitle_color'];?>" class="color {required:false}"  name="fto_blogtitle_color" id="number-input" /></label>
            
            &nbsp;&nbsp;&nbsp; 
            <label><?php esc_html_e('Size','fto');?> <input type="text" value="<?php echo $settings['fto_blogtitle_size'];?>" name="fto_blogtitle_size" id="number-input" style="width:35px;" />px </label>
    
            &nbsp;&nbsp;&nbsp; 
            <select name='fto_blogtitle_font' id='font-input'>
              		<option  value=""> <?php esc_html_e('- Font Family -','fto');?> </option>
                    <option  value="1" <?php if ( '1'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                    <option  value="2" <?php if ( '2'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                    <option  value="3" <?php if ( '3'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                    <option  value="4" <?php if ( '4'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                    <option  value="5" <?php if ( '5'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                    <option  value="6" <?php if ( '6'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                    <option  value="7" <?php if ( '7'==$settings['fto_blogtitle_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
            </select>
            &nbsp;&nbsp;&nbsp;
            <select name='fto_blogtitle_align' id='align-input' >
                    <option  value="" > <?php esc_html_e('- Text Align -','fto');?> </option>
                    <option  value="left" <?php if ( 'left'==$settings['fto_blogtitle_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Left','fto');?></option>
                    <option  value="center" <?php if ( 'center'==$settings['fto_blogtitle_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Center','fto');?></option>
                    <option  value="right" <?php if ( 'right'==$settings['fto_blogtitle_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Right','fto');?></option>
            </select>
            
            &nbsp;&nbsp;&nbsp;
            </span>
            
            <label><input type="checkbox" value="1" name="fto_blogtitle_hide" id="hide_2" <?php if ( $settings['fto_blogtitle_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide blog title','fto'); ?></label>
            </td>
            </tr>
    <?php } //end of blog title ?>
        
        
    <?php if ( $fitr_registered_options['blogdescription'] ) { ?>
            <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Tagline','fto'); ?></th>
            <td>
        
          
            <span id="hide_3_box">
            <label> <?php esc_html_e('Color','fto');?> #<input  type="text" value="<?php echo $settings['fto_blogdescription_color'];?>" class="color {required:false}"  name="fto_blogdescription_color" id="number-input" /></label>
            
            &nbsp;&nbsp;&nbsp; 
            <label><?php esc_html_e('Size','fto'); ?> <input type="text" value="<?php echo $settings['fto_blogdescription_size'];?>" name="fto_blogdescription_size" id="number-input" style="width:35px;" />px </label>
    
            &nbsp;&nbsp;&nbsp; 
            <select name='fto_blogdescription_font' id='font-input' >
              <option  value=""><?php esc_html_e('- Font Family -','fto');?></option>
                    <option  value="1" <?php if ( '1'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                    <option  value="2" <?php if ( '2'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                    <option  value="3" <?php if ( '3'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                    <option  value="4" <?php if ( '4'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                    <option  value="5" <?php if ( '5'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                    <option  value="6" <?php if ( '6'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                    <option  value="7" <?php if ( '7'==$settings['fto_blogdescription_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
             </select>
             
             &nbsp;&nbsp;&nbsp;
             <select name='fto_blogdescription_align' id='align-input' >
                    <option  value=""> <?php esc_html_e('- Text Align -','fto'); ?> </option>
                    <option  value="left" <?php if ( 'left'==$settings['fto_blogdescription_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Left','fto');?></option>
                    <option  value="center" <?php if ( 'center'==$settings['fto_blogdescription_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Center','fto');?></option>
                    <option  value="right" <?php if ( 'right'==$settings['fto_blogdescription_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Right','fto');?></option>
             </select>
             &nbsp;&nbsp;&nbsp;
             </span>
             
             <label><input type="checkbox" value="1" name="fto_blogdescription_hide" id="hide_3" <?php if ( $settings['fto_blogdescription_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide blog description','fto'); ?></label>
             </td>
             </tr>
      <?php } ?>
        
      <?php do_action('fto_header_action'); ?>

  
	  </table>
	</fieldset >
    
    <?php if ( (!empty( $fitr_registered_styles) ) || (isset( $fto_custom_fields) ) ) : ?>
     <fieldset class="options" id="show-this-fieldset">
     <h3><?php $current = current_theme_info();echo $current->name; ?> </h3>
        <table class="form-table" id="theme_options">
            
            <?php if ( !empty( $fitr_registered_styles) ) { ?>
                    <tr valign="top">
                    <th scope="row">
                	<?php esc_html_e('Available Styles','fto');?></th> 
                    <td><table><tr>
					 					<td>
                                        <?php $prev_link = esc_url(get_option('home') . '/');
										if ( is_ssl() ) 
											$prev_link = str_replace( 'http://', 'https://', $prev_link );
											
										$prev_link = htmlspecialchars(add_query_arg( array('preview' => 1, 'width'=> 750, 'height'=> 550 ,'import_style'=>':1','TB_iframe' => 'true'), $prev_link ));
										?>
                                        <a href="<?php echo $prev_link; ?>" class="thickbox thickbox-preview" title="<?php esc_html_e('Preview','fto');?> &#8220;<?php esc_html_e('Default','fto'); ?>&#8221;">
                                            <img src="<?php 
                                            if ( $current->screenshot ) {
                                                bloginfo('template_directory'); echo '/'. $current->screenshot;
                                            }else{
                                                echo FTO_PATH.'/script/no-image.jpg';
                                            }?>" 
                                            width="100px" height="100px" style="border:1px solid #ccc;" />
                                        </a>
                                             
                                        <div style="display: none" class="available-theme">
<a class="previewlink" href="<?php echo $prev_link;?>"><?php esc_html_e('Preview');?> &#8220;<?php echo $style['name']; ?>&#8221;</a> </div>
                                         <p style="margin:0px 0 0px 0;padding:0;">
                                         <center><label><input type="radio" name="fto_import_style" value="" <?php if (! $settings['fto_import_style'] ) echo 'checked="checked" ';?> /> <?php esc_html_e('Default','fto');?></label></center> 
                                         </td>

                		
								<?php
								  $i='1';
								
								  foreach ( $fitr_registered_styles as $style ) { 
								  		$path=get_template_directory().'/'.$style['path'];
										
								  		if (!file_exists($path))
											continue;
											
										$prev_link = esc_url(get_option('home') . '/');
										if ( is_ssl() ) 
											$prev_link = str_replace( 'http://', 'https://', $prev_link );
											
										$prev_link =  htmlspecialchars(add_query_arg( array('preview' => 1, 'stylesheet' => $current->stylesheet, 'import_style' => $style['path'], 'width'=> 750, 'height'=> 550 ,'TB_iframe' => 'true' ), $prev_link )) ;?>
                                 
                                         <td>
                                         <a href="<?php echo $prev_link; ?>" class="thickbox thickbox-preview" title="<?php esc_html_e('Preview');?> &#8220;<?php echo $style['name']; ?>&#8221;"><img src="<?php if ( $style['screenshot'] ) {bloginfo('template_directory'); echo '/'. $style['screenshot'];}else{echo FTO_PATH.'/script/no-image.jpg';} ?>" width="100px" height="100px" style="border:1px solid #ccc;" /></a><div style="display: none" class="available-theme">
<a class="previewlink" href="<?php echo $prev_link;?>"><?php esc_html_e('Preview');?> &#8220;<?php echo $style['name']; ?>&#8221;</a> </div>


                                         <p style="margin:0px 0 0px 0;padding:0;">
                                         <center><label><input type="radio" name="fto_import_style" value="<?php echo $style['path']; ?>" <?php if ( $settings['fto_import_style']==$style['path'] ) echo 'checked="checked" ';?> /> <?php echo $style['name'];?></label></center> 
                                         </td>
										<?php 
										$i++;
										if ( 0==( $i % 5)  ) echo '</tr><tr>';?>
                			<?php } 
							?>
                       </tr></table>
                    </td>
         			</tr>
            <?php } ?>
            
            <?php if ( isset( $fto_custom_fields) ) {
						foreach ( $fto_custom_fields as $field) {
							echo '<tr valign="top"><th scope="row">';
							 $name=str_replace('_',' ',strtoupper(substr( $field['name'],0,1) ).substr( $field['name'],1,40) );
							 echo $name .'</th><td>';
							switch ( $field['type'] ) {
								case 'text' :
									echo '<input name="'.$field['name'].'" type="text" class="fto-text" id="fto-text-'.$field['name'].'" value="'.$settings[$field['name']].'"/>';
									if ( $field['description'] ) echo ' <span class="description">'.$field['description'].'</span>';
								break;
								
								case 'number' :
									echo '<input name="'.$field['name'].'" type="text" class="fto-number" id="number-input" value="'.$settings[$field['name']].'"/>';
									if ( $field['description'] ) echo ' <span class="description">'.$field['description'].'</span>';
								break;
								
								case 'color' :
									echo '#<input name="'.$field['name'].'" type="text" class="color {required:false}" id="number-input" value="'.$settings[$field['name']].'"/>';
									if ( $field['description'] ) echo ' <span class="description">'.$field['description'].'</span>';
								break;
								
								case 'radio' :
									if ( $field['description'] ) echo $field['description'].'<br/>';
									if ( $field['options'] ) {
										foreach ( $field['options'] as $option) {
											echo '<label><input name="'.$field['name'].'" type="radio" class="fto-radio" id="fto-radio'.$field['name'].'" value="'.$option.'"';
											if ( $option==$settings[$field['name']] ) echo 'checked="checked"';
											echo " />".$option."</label>&nbsp;&nbsp;&nbsp;&nbsp;";
										}
									}
									
								break;
								
								case 'dropdown' :
									$list='';
									echo '<select class="fto-dropdown" name="'. $field['name'].'" id="fto-dropdown-'. $field['name'].'" >';
									if ( $field['options'] ) {
										foreach ( $field['options'] as $option) {
											if ( ( $option)&&( $option==$settings[$field['name']] ) ){
												$list.= "<option value=\"{$option}\" selected=\"selected\">{$option}</option>\n";
											}else{
												$list.="<option value=\"{$option}\">{$option}</option>\n";
											}
										}
									}
									echo $list.'</select>';
									if ( $field['description'] ) echo ' <span class="description">'.$field['description'].'</span>';
								break;
								
								case 'checkbox' :
									echo '<label><input name="'.$field['name'].'" type="checkbox" class="fto-checkbox" id="fto-checkbox-'.$field['name'].'" value="1" ';
									if ( $settings[$field['name']] ) 
										echo 'checked="checked"';
									echo ' /> '.$field['description'].'</label>';
								break;
								
								case 'textarea' :
									if ( $field['description'] ) echo '<span class="description">'.$field['description'].'</span><br/>';
									echo '<textarea name="'.$field['name'].'" rows="4" cols="50" class="fto-textarea" id="fto-textarea-'.$field['name'].'">';
										echo $settings[$field['name']];
									echo '</textarea>';
								break;
								
								case 'cat' :
									wp_dropdown_categories('orderby=id&order=ASC&hide_empty=0&echo=1&selected='.$settings[$field['name']].'&name='.$field['name'].'&hierarchical=1&exclude=&class=fto_cat');
									if ( $field['description'] ) echo '<span class="description">'.$field['description'].'</span>'; 
								break;
								
								case 'page' :
								echo $field['description'].'<br/>'; 
								//Taken form Mandigo Theme
								$pages = &get_pages('sort_column=menu_order');
								foreach ( $pages as $page) {
									$list_of_pages .= sprintf(
										'%s<label><input type="checkbox" value="%s" name="%s" %s /> %s</label><br />',
										( $page->post_parent ? '&nbsp;&nbsp;&nbsp;' : ''),
										$page->ID,
										$field['name'].'[]',
										(
											@in_array( $page->ID, $settings[$field['name']] )
											? ' checked'
											: ''
										),
										$page->post_title
									);
								}
								echo $list_of_pages;
								break;
				
								
							}//end switch	
							echo '</td></tr>';
						}//end forach
					}
           			do_action('fto_theme_option_action'); ?>
               
       		</table>
   		</fieldset>
    <?php endif; ?>
    
    
    <fieldset class="options" id="show-this-fieldset">
       <h3><?php esc_html_e('General','fto');?> </h3>
	
	 	<table class="form-table" id="general_options">
            <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Page Body','fto');?></th>
            <td>
            <label> <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_body_bgcolor'];?>" class="color {required:false}"  name="fto_body_bgcolor" id="number-input" /></label> 
            
            <label>  <?php esc_html_e('or Background Image URL','fto');?> <input type="text" value="<?php echo $settings['fto_bodybgimg_url'];?>"  name="fto_bodybgimg_url" id="url" style="width:250px;"/></label> 
            &nbsp;&nbsp;
            <select name='fto_bodybg_format' id='linkformat-input'>
                    <option  value=""> <?php esc_html_e('- Image Type -','fto');?> </option>
                    <option  value="no-repeat-fixed" <?php if ( 'no-repeat-fixed'==$settings['fto_bodybg_format'] ) echo 'selected="selected"';?>>No Repeat, Fixed</option>
                    <option  value="x-repeat-fixed" <?php if ( 'x-repeat-fixed'==$settings['fto_bodybg_format'] ) echo 'selected="selected"';?>>X Repeat, Fixed</option>
                    <option  value="x-repeat" <?php if ( 'x-repeat'==$settings['fto_bodybg_format'] ) echo 'selected="selected"';?>>X Repeat</option>
                    <option  value="y-repeat" <?php if ( 'y-repeat'==$settings['fto_bodybg_format'] ) echo 'selected="selected"';?>>Y Repeat</option>
                    <option  value="repeat" <?php if ( 'repeat'==$settings['fto_bodybg_format'] ) echo 'selected="selected"';?>>Repeat</option>
             </select>
             <a href="http://wpwave.com/plugins/fitr-theme-options/#what-is-repeat"><?php esc_html_e('Help');?></a> 
            </td>
           </tr>

           <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Link','fto');?></th>
            <td>
      
            <label> <?php esc_html_e('Color','fto');?> #<input type="text" value="<?php echo $settings['fto_link_color'];?>" class="color {required:false}"  name="fto_link_color" id="number-input" /></label>
            
             &nbsp;&nbsp;&nbsp;
             
             <?php esc_html_e('Mouse Over Color','fto');?> #<input  type="text" value="<?php echo $settings['fto_link_hover'];?>" class="color {required:false}"  name="fto_link_hover" id="number-input" />
             
             &nbsp;&nbsp;&nbsp;
             <select name='fto_link_format' id='linkformat-input' >
                    <option  value=""> <?php esc_html_e('- Link Format -','fto');?> </option>
                    <option  value="none" <?php if ( 'none'==$settings['fto_link_format'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
                    <option  value="underline" <?php if ( 'underline'==$settings['fto_link_format'] ) echo 'selected="selected"';?>><?php esc_html_e('Underline','fto');?></option>
                    <option  value="underdash" <?php if ( 'underdash'==$settings['fto_link_format'] ) echo 'selected="selected"';?>><?php esc_html_e('Underdash','fto');?></option>
                    <option  value="overline" <?php if ( 'overline'==$settings['fto_link_format'] ) echo 'selected="selected"';?>><?php esc_html_e('Overline','fto');?></option>
             </select>
            </td>
           </tr>
             
             <?php if ( $fitr_registered_options['container'] ) { ?>
    			<tr valign="top">
                    <th scope="row">
                    <?php esc_html_e('Container','fto');?></th>
                    <td>
             
                     <label> <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_container_bgcolor'];?>" class="color {required:false}"  name="fto_container_bgcolor" id="number-input" /></label>        
                    
                    </td>
            	</tr>
            <?php } //end container ?>
    
           		<tr valign="top">
                    <th scope="row">
                    <?php esc_html_e('Text Direction','fto');?></th>
                    <td>
             
                     <select name='fto_text_direction' id='direction-input' >
                            <option  value="" > <?php esc_html_e('- Direction -','fto'); ?></option>
                            <option  value="rtl" <?php if ( 'rtl'==$settings['fto_text_direction'] ) echo 'selected="selected"';?>><?php esc_html_e('Right to Left','fto'); ?></option>
                            <option  value="ltr" <?php if ( 'ltr'==$settings['fto_text_direction'] ) echo 'selected="selected"';?>><?php esc_html_e('Left to Right','fto'); ?></option>    
                     </select>

                    </td>
           		</tr>
            
            
            
           
    
            <tr valign="top">
                  <th scope="row">
                    <?php esc_html_e('RSS and Feedburner','fto');?></th>
                    <td>
                    <label><?php esc_html_e('Feedburner ID','fto');?> <input type="text" value="<?php echo $settings['fto_feedburner_id'];?>" name="fto_feedburner_id" id="feed"/> </label>
                    
                    &nbsp;&nbsp;&nbsp;
                     <?php if ( $fitr_registered_options['feedicon'] ) { ?>
                            <label><input type="checkbox" value="1" <?php if ( $settings['fto_feedicon_hide'] ) echo 'checked="checked"';?> name="fto_feedicon_hide" id="hide"/> <?php esc_html_e('Hide feed icon','fto');?></label>
    				<?php } //end feed icon?>
                    </td>
            </tr>
            
    
            <tr valign="top">
                    <th scope="row">
                    <?php esc_html_e('Image Caption','fto');?></th>
                    <td>
                      <label><input type="checkbox" value="1" name="fto_image_styles" id="default_style" <?php if ( $settings['fto_image_styles'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Some themes does not support image caption and image align. Check out this box to add this feature.','fto');?></label>
                    </td>
            </tr>
            
            <?php do_action('fto_general_action'); ?>
    
     </table>
	</fieldset>
    
    <?php if ( ( $fitr_registered_options['menubar'] ) || ( $fitr_registered_options['menuli_bg'] ) || ( $fitr_registered_options['menuli_a'] ) ) : ?>
        <fieldset class="options" id="show-this-fieldset">
         <h3><?php esc_html_e('Menu','fto');?></h3>
        
         <table class="form-table" id="menu_options">
         
        <?php if ( $fitr_registered_options['menubar'] ) { ?>   
                <tr valign="top">
                 <th scope="row">
                 <?php esc_html_e('Menubar','fto');?></th>
                 <td>
                 <span id="hide_4_box">
                 <label>  <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_menubar_bgcolor'];?>" class="color {required:false}"  name="fto_menubar_bgcolor" id="number-input" /></label>  
                  &nbsp;&nbsp;&nbsp;
                </span>
           		<label><input type="checkbox" value="1" name="fto_menubar_hide" id="hide_4" <?php if ( $settings['fto_menubar_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide Menu','fto');?></label>
     
               </td>
              </tr>
       <?php } ?>
           
           
       <?php if ( ( $fitr_registered_options['menuli_bg'] )  || ( $fitr_registered_options['menuli_bghover'] ) ){ ?>
                <tr valign="top" id="hide_4_box_2">
                 <th scope="row"><?php esc_html_e('Menu Item','fto');?></th><td>
                 <?php if ( $fitr_registered_options['menuli_bg'] ) { ?>
                 <label><?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_menu_bgcolor'];?>" class="color {required:false}"  name="fto_menu_bgcolor" id="number-input" /></label>
                &nbsp;&nbsp;&nbsp;
                 <?php }?>
           
                <?php if ( $fitr_registered_options['menuli_bghover'] ) { ?>
                 <label> <?php esc_html_e('Mouse Over Background Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_menu_bghover'];?>" class="color {required:false}"  name="fto_menu_bghover" id="number-input" /></label>
                 &nbsp;&nbsp;&nbsp;
                <?php }//end of menuli_bghover ?>
            
           		</td>
               </tr>
           <?php } // end of menuli_bg and hover ?>
           
           
    <?php if ( ( $fitr_registered_options['menuli_a'] ) ) { ?>
            <tr valign="top" id="hide_4_box_3">
             <th scope="row">
             <?php esc_html_e('Menu Item Link','fto');?></th>
             <td>
             <?php  if ( $fitr_registered_options['menuli_a'] ) { ?>

               <label> <?php esc_html_e('Color','fto');?> #<input type="text" value="<?php echo $settings['fto_menuli_a_color'];?>" class="color {required:false}"  name="fto_menuli_a_color" id="number-input" /></label>
               &nbsp;&nbsp;&nbsp;
          
               <label> <?php esc_html_e('Mouse Over Color','fto');?> #<input type="text" value="<?php echo $settings['fto_menuli_ahover_color'];?>" class="color {required:false}"  name="fto_menuli_ahover_color" id="number-input" /></label>
               &nbsp;&nbsp;&nbsp;
               
               <label><?php esc_html_e('Size','fto');?> <input type="text" value="<?php echo $settings['fto_menuli_a_size'];?>" name="fto_menuli_a_size" id="number-input" style="width:35px;" />px </label>
               &nbsp;&nbsp;&nbsp; 
               
         	  <?php } ?>

            </td>
           </tr>

  <?php }//end menuli_a and hover ?>
       
       <?php do_action('fto_menu_action'); ?>
     </table>
	</fieldset>
    
    <?php endif //end main menubar?>
    
    
    <?php if ( ( $fitr_registered_options['postbox'] ) || ( $fitr_registered_options['posttitle'] ) || ( $fitr_registered_options['postcontent'] ) || ( $fitr_registered_options['postmeta'] ) ) : ?>
    <fieldset class="options" id="show-this-fieldset">
	  <h3><?php esc_html_e('Post','fto');?></h3>
	
	 <table class="form-table" id="post_options">
     
     <?php if ( $fitr_registered_options['postbox'] ) { ?>
      <tr valign="top">
        <th scope="row">
        <?php esc_html_e('Post Box','fto');?></th>
        <td>
 
        <label> <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_postbox_bgcolor'];?>" class="color {required:false}"  name="fto_postbox_bgcolor" id="number-input" /></label>
        
        &nbsp;&nbsp;&nbsp; 
         <select name='fto_postbox_border' id='border-input' >
       			<option  value=""> <?php esc_html_e('- Border -','fto');?> </option>
                <option  value="none" <?php if ( 'none'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
                <option  value="fullborder" <?php if ( 'fullborder'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Full','fto');?></option>
                <option  value="dashedborder" <?php if ( 'dashedborder'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Dashed','fto');?></option>
                <option  value="topborder" <?php if ( 'topborder'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Top','fto');?></option>
                <option  value="botborder" <?php if ( 'botborder'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Bottom','fto');?></option>
                <option  value="topbotborder" <?php if ( 'topbotborder'==$settings['fto_postbox_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Top+Bottom ','fto');?></option>
               
		 </select>
      
        </td>
       </tr>
       <?php } ?>
       
     	<?php if ( $fitr_registered_options['posttitle'] ) { ?>
     	<tr valign="top">
        <th scope="row">
        <?php esc_html_e('Post Title','fto'); ?></th>
        <td>
 
        <label> <?php esc_html_e('Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_posttitle_color'];?>" class="color {required:false}"  name="fto_posttitle_color" id="number-input" /></label>
		
        &nbsp;&nbsp;&nbsp; 
        <label><?php esc_html_e('Size','fto'); ?> <input type="text" value="<?php echo $settings['fto_posttitle_size'];?>" name="fto_posttitle_size" id="number-input" style="width:35px;" />px </label>

        &nbsp;&nbsp;&nbsp; 
        <select name='fto_posttitle_font' id='font-input' >
		  <option  value=""><?php esc_html_e('- Font Family -','fto');?></option>
                <option  value="1" <?php if ( '1'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                <option  value="2" <?php if ( '2'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                <option  value="3" <?php if ( '3'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                <option  value="4" <?php if ( '4'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                <option  value="5" <?php if ( '5'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                <option  value="6" <?php if ( '6'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                <option  value="7" <?php if ( '7'==$settings['fto_posttitle_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
	    </select>
        
       &nbsp;&nbsp;&nbsp;
	   	   <select name='fto_posttitle_border' id='border-input' >
       			<option  value=""> <?php esc_html_e('- Border -','fto'); ?> </option>
               <option  value="none" <?php if ( 'none'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
                <option  value="fullborder" <?php if ( 'fullborder'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Full','fto');?></option>
                <option  value="dashedborder" <?php if ( 'dashedborder'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Dashed','fto');?></option>
                <option  value="topborder" <?php if ( 'topborder'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Top','fto');?></option>
                <option  value="botborder" <?php if ( 'botborder'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Bottom','fto');?></option>
                <option  value="topbotborder" <?php if ( 'topbotborder'==$settings['fto_posttitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Top+Bottom ','fto');?></option>
		 </select>
       
       </td></tr>
       <?php } ?>
       
       
       <?php if ( $fitr_registered_options['postcontent'] ) { ?>
         <tr valign="top">
            <th scope="row">
            <?php esc_html_e('Post Content','fto'); ?></th>
            <td>
     
            <label> <?php esc_html_e('Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_postcontent_color'];?>" class="color {required:false}"  name="fto_postcontent_color" id="number-input" /></label>
            
            &nbsp;&nbsp;&nbsp; 
            <label><?php esc_html_e('Size','fto'); ?> <input type="text" value="<?php echo $settings['fto_postcontent_size'];?>" name="fto_postcontent_size" id="number-input" style="width:35px;" />px </label>
    
            &nbsp;&nbsp;&nbsp; 
            <select name='fto_postcontent_font' id='font-input' >
              	<option  value=""><?php esc_html_e('- Font Family -','fto'); ?></option>
                <option  value="1" <?php if ( '1'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                <option  value="2" <?php if ( '2'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                <option  value="3" <?php if ( '3'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                <option  value="4" <?php if ( '4'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                <option  value="5" <?php if ( '5'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                <option  value="6" <?php if ( '6'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                <option  value="7" <?php if ( '7'==$settings['fto_postcontent_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
            </select>
            
            &nbsp;&nbsp;&nbsp;
           <label><input type="checkbox" value="1" name="fto_postcontent_justify"  <?php if ( $settings['fto_postcontent_justify'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Justify content','fto'); ?></label>  
           
            
          </td></tr>
     <?php } ?> 
       
     <?php if ( $fitr_registered_options['postmeta'] ) { ?>
        <tr valign="top">
         <th scope="row">
         <?php esc_html_e('Post Meta','fto');?></th>
         <td>
 		 <span id="hide_5_box">
         <label> <?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_postmeta_bgcolor'];?>" class="color {required:false}"  name="fto_postmeta_bgcolor" id="number-input" /></label>
        
         &nbsp;&nbsp;&nbsp; 
         <label> <?php esc_html_e('Color','fto');?> #<input type="text" value="<?php echo $settings['fto_postmeta_color'];?>" class="color {required:false}"  name="fto_postmeta_color" id="number-input" /></label>
         &nbsp;&nbsp;&nbsp;
         <select name='fto_postmeta_align' id='align-input' >
       			<option  value=""> <?php esc_html_e('- Text Align -','fto'); ?> </option>
                <option  value="left" <?php if ( 'left'==$settings['fto_postmeta_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Left','fto');?></option>
                <option  value="center" <?php if ( 'center'==$settings['fto_postmeta_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Center','fto');?></option>
                <option  value="right" <?php if ( 'right'==$settings['fto_postmeta_align'] ) echo 'selected="selected"';?>><?php esc_html_e('Right','fto');?></option>
		 </select>
         
         &nbsp;&nbsp;&nbsp;
       </span>
       <label><input type="checkbox" value="1" name="fto_postmeta_hide" id="hide_5" <?php if ( $settings['fto_postmeta_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide Postmeta','fto'); ?></label> 
        
       </td></tr>

      
       <tr valign="top">
        <th scope="row">
        <label></label></th>
        <td>
  		<?php if ( $fitr_registered_options['date'] ) { ?>
           <label><input type="checkbox" value="1" name="fto_date_hide" id="hide_it" <?php if ( $settings['fto_date_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide Date','fto'); ?></label>  
           &nbsp;&nbsp;&nbsp;
        <?php } ?>
        
        <?php if ( $fitr_registered_options['author'] ) { ?>
           <label><input type="checkbox" value="1" name="fto_author_hide" id="hide_it" <?php if ( $settings['fto_author_hide'] ) echo 'checked="checked"';?>/>  <?php esc_html_e('Hide Author','fto'); ?></label>  
           &nbsp;&nbsp;&nbsp;
        <?php } ?>
        
        <?php if ( $fitr_registered_options['trackback'] ) { ?>
           <label><input type="checkbox" value="1" name="fto_trackback_hide" id="hide_it" <?php if ( $settings['fto_trackback_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide Trackback','fto'); ?></label>  
           &nbsp;&nbsp;&nbsp;
        <?php } ?>
        
        <?php if ( $fitr_registered_options['allowed_html'] ) { ?>
           <label><input type="checkbox" value="1" name="fto_allowed_html_hide" id="hide_it" <?php if ( $settings['fto_allowed_html_hide'] ) echo 'checked="checked"';?>/> <?php esc_html_e('Hide Allowed HTML Tags','fto'); ?></label>  
           &nbsp;&nbsp;&nbsp;
		<?php } ?>
        
       </td>
      </tr>
   
     <?php } ?>
       
       <?php do_action('fto_post_action'); ?>
       </table>
       </fieldset>
    
    <?php endif; ?>
    
    <?php if ( ( $fitr_registered_options['sidebarbody'] ) || ( $fitr_registered_options['widgetbox'] ) || ( $fitr_registered_options['widgettitle'] ) || ( $fitr_registered_options['widgetli_a'] ) ) : ?>
    
    <fieldset class="options" id="show-this-fieldset">
    <h3><?php esc_html_e('Sidebar(s)','fto'); ?></h3>
	
	 <table class="form-table" id="sidebar_options">   
     
      <?php if ( $fitr_registered_options['sidebarbody'] ) { ?>
        <tr valign="top">
        <th scope="row">
        <?php esc_html_e('Sidebar Body','fto'); ?></th>
        <td>
 		<label><?php esc_html_e('Background Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_sidebarbody_bgcolor'];?>" class="color {required:false}"  name="fto_sidebarbody_bgcolor" id="number-input" /></label>
      &nbsp;&nbsp;&nbsp;

       
      <select name='fto_sidebarbody_border' id='border-input' >
            <option  value=""> <?php esc_html_e('- Border -','fto'); ?> </option>
            <option  value="none" <?php if ( 'none'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
            <option  value="fullborder" <?php if ( 'fullborder'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Full','fto');?></option>
            <option  value="dashedborder" <?php if ( 'dashedborder'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Dashed','fto');?></option>
            <option  value="rightborder" <?php if ( 'rightborder'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Right','fto');?></option>
            <option  value="leftborder" <?php if ( 'leftborder'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Left','fto');?></option>
            <option  value="riglefborder" <?php if ( 'riglefborder'==$settings['fto_sidebarbody_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Left+Right','fto');?></option>
                
         
		 </select>
        
       </td></tr>
       <?php } ?>
       
       
       <?php if ( $fitr_registered_options['widgetbox'] ) { ?>
        <tr valign="top">
        <th scope="row">
        <?php esc_html_e('Widget Box','fto');?></th>
        <td>
 		<label><?php esc_html_e('Background Color','fto');?> #<input  type="text" value="<?php echo $settings['fto_widget_bgcolor'];?>" class="color {required:false}"  name="fto_widget_bgcolor" id="number-input" /></label>
       &nbsp;&nbsp;&nbsp;
       
       <label><?php esc_html_e('Color','fto');?> #<input  type="text" value="<?php echo $settings['fto_widget_color'];?>" class="color {required:false}"  name="fto_widget_color" id="number-input" /></label>
       &nbsp;&nbsp;&nbsp;
       
       
       <select name='fto_wdiget_font' id='font-input' >
		  		<option  value=""><?php esc_html_e('- Font Family -','fto'); ?></option>
                <option  value="1" <?php if ( '1'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                <option  value="2" <?php if ( '2'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                <option  value="3" <?php if ( '3'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                <option  value="4" <?php if ( '4'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                <option  value="5" <?php if ( '5'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                <option  value="6" <?php if ( '6'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                <option  value="7" <?php if ( '7'==$settings['fto_wdiget_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
	  </select>
        
      &nbsp;&nbsp;&nbsp; 
      <select name='fto_widget_border' id='border-input' >
               <option  value=""> <?php esc_html_e('- Border -','fto'); ?> </option>
               <option  value="none" <?php if ( 'none'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
               <option  value="fullborder" <?php if ( 'fullborder'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Full','fto');?></option>
               <option  value="dashedborder" <?php if ( 'dashedborder'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Dashed','fto');?></option>
               <option  value="rightborder" <?php if ( 'rightborder'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Right','fto');?></option>
               <option  value="leftborder" <?php if ( 'leftborder'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Left','fto');?></option>
               <option  value="riglefborder" <?php if ( 'riglefborder'==$settings['fto_widget_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Left+Right','fto');?></option>
		 </select>

        
       </td>
      </tr>
      <?php } ?>
       
       
       <?php if ( $fitr_registered_options['widgetli_a'] ) { ?>
       <tr valign="top">
        <th scope="row">
        <?php esc_html_e('Widget Link','fto');?></th>
        <td>
       
 		<label><?php esc_html_e('Color','fto');?> #<input type="text" value="<?php echo $settings['fto_widgetli_a_color'];?>" class="color {required:false}"  name="fto_widgetli_a_color" id="number-input" /></label>
       &nbsp;&nbsp;&nbsp;
       
       <label><?php esc_html_e('Mouse Over Color','fto');?> #<input type="text" value="<?php echo $settings['fto_widgetlihover_color'];?>" class="color {required:false}"  name="fto_widgetlihover_color" id="number-input" /></label>

        
       </td></tr>
       <?php } ?>
       
       
       <?php if ( $fitr_registered_options['widgettitle'] ) { ?>
        <tr valign="top">
        <th scope="row">
        <?php esc_html_e('Widget Title','fto');?></th>
        <td>
        <label><?php esc_html_e('Background Color','fto');?> #<input type="text" value="<?php echo $settings['fto_widgettitle_bgcolor'];?>" class="color {required:false}"  name="fto_widgettitle_bgcolor" id="number-input" /></label>
        
         &nbsp;&nbsp;&nbsp; 
         
 		<label> <?php esc_html_e('Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_widgettitle_color'];?>" class="color {required:false}"  name="fto_widgettitle_color" id="number-input" /></label>
       &nbsp;&nbsp;&nbsp;
       
      
        <label><?php esc_html_e('Size','fto'); ?> <input type="text" value="<?php echo $settings['fto_widgettitle_size'];?>" name="fto_widgettitle_size" id="number-input" style="width:35px;" />px </label>
        
   		&nbsp;&nbsp;&nbsp;
        <select name='fto_widgettitle_font' id='font-input' >
		  <option  value=""><?php esc_html_e('- Font Family -','fto');?></option>
                <option  value="1" <?php if ( '1'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Arial, Helvetica, sans-serif</option>
                <option  value="2" <?php if ( '2'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Times New Roman, Times, serif</option>
                <option  value="3" <?php if ( '3'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Courier New, Courier, monospace</option>
                <option  value="4" <?php if ( '4'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Georgia, Times New Roman, serif</option>
                <option  value="5" <?php if ( '5'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Verdana, Arial, Helvetica, sans-serif</option>
                <option  value="6" <?php if ( '6'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Geneva, Arial, Helvetica, sans-serif</option>
                <option  value="7" <?php if ( '7'==$settings['fto_widgettitle_font'] ) echo 'selected="selected"';?>>Tahoma, sans-serif</option>
	    </select>
        
 		 &nbsp;&nbsp;
	   	<select name='fto_widgettitle_border' id='border-input' >
       			<option  value=""> <?php esc_html_e('- Border -','fto');?> </option>
                <option  value="none" <?php if ( 'none'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('None','fto');?></option>
                <option  value="fullborder" <?php if ( 'fullborder'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Full','fto');?></option>
                <option  value="dashedborder" <?php if ( 'dashedborder'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Dashed','fto');?></option>
                <option  value="topborder" <?php if ( 'topborder'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Top','fto');?></option>
                <option  value="botborder" <?php if ( 'botborder'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Only Bottom','fto');?></option>
                <option  value="topbotborder" <?php if ( 'topbotborder'==$settings['fto_widgettitle_border'] ) echo 'selected="selected"';?>><?php esc_html_e('Top+Bottom ','fto');?></option>
		 </select>
        
         
       </td>
      </tr>
      <?php } ?>
         
      <?php do_action('fto_sidebar_action'); ?>
    </table>
   </fieldset>
  <?php endif; ?>
       
       
    <fieldset class="options" id="show-this-fieldset">
      <h3><?php esc_html_e('Footer','fto'); ?></h3>
      
	  	<table class="form-table" id="footer_options">   
       
        <tr valign="top">
        <th scope="row">
        
        <?php esc_html_e('Footer','fto'); ?></th>
        <td>
        <?php if ( $fitr_registered_options['footer'] ) { ?>
 		<label><?php esc_html_e('Background Color','fto'); ?> #<input type="text" value="<?php echo $settings['fto_footer_bgcolor'];?>" class="color {required:false}"  name="fto_footer_bgcolor" id="number-input" /></label>
     
		<?php } ?>
       
     	<p><?php if ( !fto_is_wpmu() )
					esc_html_e('You can place XHTML here to have it inserted automatically into your footer theme.','fto'); 
				else
					esc_html_e('You can place XHTML or Javascript (e.g. for counters) here to have it inserted automatically into your footer theme.','fto'); ?>
		<br/>
       
      <textarea name="fto_footer_code" class="footercode" rows="4" cols="60"><?php echo $settings['fto_footer_code'];?></textarea></p>
        
       </td>
       </tr>
       
       <?php do_action('fto_footer_action'); ?>
      </table>
    </fieldset>
     
    <fieldset class="options" id="show-this-fieldset">
       <h3 id="preview_h3"><?php esc_html_e('Preview','fto'); ?></h3>

          <div id="preview">
        	<?php $ajax=esc_url(get_option('siteurl')."/wp-admin/admin-ajax.php"); ?>
            <input class="button" name="refresh" id="refresh"  value="<?php esc_attr_e('Update Preview','fto'); ?>" alt="<?php echo $ajax;?>" type="button" />
            
            <?php 
			
			$preview=esc_url(get_option('home') . '/');
			if (  is_ssl() ) $preview = str_replace( 'http://', 'https://', $preview );
			$preview = htmlspecialchars( add_query_arg( array('preview' => 1 ,'TB_iframe' => 'true' ,'fto_preview' => 'true'), $preview ) );
			?>
            <iframe style="border:3px solid #ccc;width:100%" height="500px" id="preview_frame" src="<?php echo $preview; ?>"></iframe>
          </div>
              
      </fieldset>

      <p>
      <input type="hidden" name="action" value="fto_ajax_refresh" />
      <input class="button-primary" name="fto_submit" value="<?php esc_attr_e('Save Options','fto'); ?>" type="submit" />
      <input class="button" name="fto_restore" value="<?php esc_attr_e('Restore Default','fto'); ?>" 
      
      onclick="if ( confirm(' <?php echo esc_js(__("You are about to restore and delete all of your settings \n 'Cancel' to stop, 'OK' to restore.") ) ?>') ) {return true;}return false;" type="submit" />
      <?php wp_nonce_field( 'fitr-options-ajax', '_ajax_nonce', false ); ?>
    
	</form>
    
	</div>
    <small><?php esc_html_e('Note: Empty fields and unselected boxs means default settings. Header image, stylesheet and footer code and do not apear in Live Preview.','fto');?> </small>
